import { getErrorContainer } from '../error-util';
/**
 * Shows the error notification
 * @internal
 * @param error - The ErrorStructure object
 * @param tagName - The tag name to create prefix for the design system provider & error component
 * @returns
 * */
export const showNotification = (error, tagName) => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    const tagPrefix = tagName.split('-')[0];
    const container = getErrorContainer('notify-container', tagName);
    if (container) {
        container.style.position = 'fixed';
        container.style.top = '0';
        container.style.right = '0';
    }
    const toastNotify = document.createElement(`${tagPrefix}-toast`);
    const errorTitle = document.createElement('div');
    errorTitle.setAttribute('slot', 'top');
    errorTitle.textContent = (_a = error.title) !== null && _a !== void 0 ? _a : 'Error';
    const errorDetails = document.createElement('div');
    errorDetails.setAttribute('slot', 'content');
    errorDetails.textContent = (error === null || error === void 0 ? void 0 : error.errorDetails) || '';
    const errorDate = document.createElement('div');
    errorDate.setAttribute('slot', 'date');
    errorDate.textContent = new Date().toLocaleTimeString();
    toastNotify.setAttribute('notify', ((_c = (_b = error === null || error === void 0 ? void 0 : error.config) === null || _b === void 0 ? void 0 : _b.notification) === null || _c === void 0 ? void 0 : _c.type) || '');
    ((_e = (_d = error === null || error === void 0 ? void 0 : error.config) === null || _d === void 0 ? void 0 : _d.notification) === null || _e === void 0 ? void 0 : _e.autoClose)
        ? toastNotify.setAttribute('auto-close', `${(_g = (_f = error === null || error === void 0 ? void 0 : error.config) === null || _f === void 0 ? void 0 : _f.notification) === null || _g === void 0 ? void 0 : _g.autoClose}`)
        : '';
    ((_j = (_h = error === null || error === void 0 ? void 0 : error.config) === null || _h === void 0 ? void 0 : _h.notification) === null || _j === void 0 ? void 0 : _j.closeTimeout)
        ? toastNotify.setAttribute('close-timeout', `${(_l = (_k = error === null || error === void 0 ? void 0 : error.config) === null || _k === void 0 ? void 0 : _k.notification) === null || _l === void 0 ? void 0 : _l.closeTimeout}`)
        : '';
    toastNotify.appendChild(errorTitle);
    toastNotify.appendChild(errorDetails);
    toastNotify.appendChild(errorDate);
    container.appendChild(toastNotify);
};
